
#ifndef __CSidPlayDll_H__
#define __CSidPlayDll_H__

#include <E32Base.h>

#include <sound/SoundProvider.h>

class emuEngine;
class sidTune;
struct emuConfig;
struct sidTuneInfo;



class CSidPlayDll : public CBase, public MSoundProvider
{
public:
	IMPORT_C static CSidPlayDll* NewL();
	IMPORT_C static CSidPlayDll* NewLC();
	IMPORT_C virtual ~CSidPlayDll();

public:
	IMPORT_C void LoadL( const TDesC8& aModuleData );
	IMPORT_C void Unload();
	IMPORT_C void Start();
	IMPORT_C void Stop();
	IMPORT_C void Pause( TBool aPauseFlag );

public:
	/* From MSoundProvider */
	virtual void InitL( MSoundParameters* aSoundParameters );
	virtual void AddTo( TDes16& aSoundBuffer );
	IMPORT_C virtual void SetVolume( TUint8 aVolume );
	IMPORT_C virtual TUint8 Volume();
	IMPORT_C virtual TUint8 MaxVolume();

protected:
	void UpdateWaveFormatL();
	void SetStereoL( TBool aStereoFlag );
	void SetPlayFrequencyL( TInt aFrequency );

protected:
	CSidPlayDll();
	void ConstructL();

private:
	struct emuConfig* iEmuConfig;
	emuEngine* iEmuEngine;
	struct sidTuneInfo* iSidInfo;
	sidTune* iTune;

private:
	TBool iPlaying;
	TBool iPaused;
	TBool iStereo;
	TInt iPlayFrequency;
};

#endif
